/*****************************************************************************
     This file is part of the Changedfiles system. 

     Copright (C)2002  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
/*  $Id: action.cpp,v 1.5 2002/03/09 22:25:26 philip Exp $ */
#include <string> 
#include <iostream>
#include <stdio.h> 

#include "action.h"

using std::cerr;

Action::Action(){
  m_retry = 0;
}

bool Action::first(){
  cerr << "Add initialization code";
  return false;
}

bool Action::last(){
  cerr << "Add wrap-up code" ;
  return false;
}

/** 
 * returns number of retrys left.
 */
int Action::add_retry()
{ 
  ++m_retry; 
  int trys_left = 0;
  if( m_max_retry > 0 )
    {
      trys_left = ( m_max_retry - m_retry );
      if ( trys_left < 0 ){
	trys_left = 0;
      }
    }
  else
    {
      trys_left = m_retry;
    }

  return trys_left;
} 

int Action::get_retry()
{ 
  return m_retry; 
} 

int Action::get_max_retry()
{ 
  return m_max_retry; 
}





