/**
 * Abstract base class for all actions changedfiles should
 * take on a file action notification.
 */

/**************************************************************************
 * This file is part of the Changedfiles system. Copright (C)2002  Micheal Welles
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _ACTION_H_
#define _ACTION_H_
#include "action_exception.h"

#include <string>

using std::string;

class Action {
 public:
  Action();

  virtual ~Action() { };

  virtual bool first();
  virtual bool last();
  virtual int get_retry();
  void set_max_retry(int max_retry){ this->m_max_retry = max_retry; }
  void set_timeout( time_t timeout ) { this->m_timeout = timeout; }
  virtual int add_retry();
  virtual int get_max_retry();


  virtual bool do_action() throw ( ActionException ) = 0;
  virtual string get_description() = 0;

 protected:
  int m_max_retry; 
  int m_retry;  
  time_t m_timeout;

 private:
  // nothing now...
};

#endif
